#include <ESP8266WiFi.h>

//Información de nuestro WIFI
const char *ssid = "NOMBRE_DE_TU_WIFI";
const char *password = "CONTRASEÑA_DE_TU_WIFI";
const char *programa="VACIO";
int contador=0;
const char *estado="Listo";
//Datos para una IP estática
IPAddress ip(192,168,1,181);     
IPAddress gateway(192,168,1,1);   
IPAddress subnet(255,255,255,0); 

//Definimos el pin donde está conectado el led
int ledPin = 2; 

//Puerto 80 TCP, este puerto se usa para la navegación web http
WiFiServer server(80);
 
void setup() {
  Serial.begin(115200); //Iniciamos comunicación serial
  delay(10);
  
  pinMode(ledPin, OUTPUT);  //Pin del Led como salida
  digitalWrite(ledPin, LOW);  //Ponemos la salida de led en bajo
   
  // Conectandose al Wifi
  Serial.println();
  Serial.println();
  Serial.print("Conectandose a ");
  Serial.println(ssid);

  WiFi.mode(WIFI_STA); //Wifi en modo estación
  WiFi.config(ip, gateway, subnet);//Configuramos la ip estática
  WiFi.begin(ssid, password); //Iniciamos conexión con el nombre y la contraseña del wifi que indicamos

  //Mientras se conecta se imprimiran puntos
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  
  //Cuando se conecte lo imprimimos
  Serial.println("");
  Serial.println("WiFi Conectado");
   
  // Iniciamos el esp como servidor web
  server.begin();
  Serial.println("Servidor iniciado");
 
  // Imprimimos la dirección IP
  Serial.print("Usa esta URL para comunicar al ESP: ");
  Serial.print("http://");
  Serial.print(WiFi.localIP());              
  Serial.println("/");
    
}
 
void loop() {
  // El servidor siempre estará esperando a que se conecte un cliente
  WiFiClient client = server.available();
  if (!client) {
    return;
  }
   
  
 // Serial.println("Nuevo cliente"); //Cuando un cliente se conecte vamos a imprimir que se conectó
  while(!client.available()){  //Esperamos a que el ciente mande una solicitud
    delay(1);
  }
   
  // Leemos la primer línea de la solicitud y la guardamos en la variable string request
  String request = client.readStringUntil('\r');
 Serial.println(request); //Imprimimos la solicitud
  client.flush(); //Descartamos los datos que se han escrito en el cliente y no se han leído
   
  // Relacionamos la solicitud
  if (request.indexOf("/P=ONAUTO") != -1){
    programa="ONAUTO";
    Serial.print("*");
    Serial.print(programa);
    Serial.print("*");
    estado="Listo";
    
    
  }
  if (request.indexOf("/P=OFFAUTO") != -1) {
    programa="OFFAUTO";
    Serial.print("*");
    Serial.print(programa);
    Serial.print("*");
    estado="OFF";

    
  } 
   if (request.indexOf("/P=preparar") != -1) {
    programa="preparar";
    Serial.print("*");
    Serial.print(programa);
    Serial.print("*");
    estado="Preparando";
    

    
  } 
   if (request.indexOf("/P=sacar500") != -1) {
    programa="sacar500";
    Serial.print("*");
    Serial.print(programa);
    Serial.print("*");
    contador++;
    estado="Cosechando500";

    
  } 
     if (request.indexOf("/P=sacar1000") != -1) {
    programa="sacar1000";
    Serial.print("*");
    Serial.print(programa);
    Serial.print("*");
    contador++;
    estado="Cosechando1000";

    
  } 
     if (request.indexOf("/P=Servos") != -1) {
    programa="Servos";
    Serial.print("*");
    Serial.print(programa);
    Serial.print("*");
    estado="Probando_Servos";

    
  } 
  
       if (request.indexOf("/P=OFFServos") != -1) {
    programa="OFFServos";
    Serial.print("*");
    Serial.print(programa);
    Serial.print("*");
    estado="OFF_Servos";

    
  } 
         if (request.indexOf("/P=Fito4") != -1) {
    programa="Fito4";
    Serial.print("*");
    Serial.print(programa);
    Serial.print("*");
    estado="Aditar_4Ml";

    
  }
         if (request.indexOf("/P=Fito5") != -1) {
    programa="Fito5";
    Serial.print("*");
    Serial.print(programa);
    Serial.print("*");
    estado="Aditar_5Ml";

    
  }
  if (request.indexOf("/P=Fito6") != -1) {

    programa="Fito6";
    Serial.print("*");
    Serial.print(programa);
    Serial.print("*");
    estado="Aditar_6Ml";
  } 
   
     if (request.indexOf("/P=Reset") != -1) {

    contador=0;
    estado="Reset-Contador";
  } 

  
 

  // Respuesta del servidor web
  
  client.println("HTTP/1.1 200 OK"); // La respuesta empieza con una linea de estado  
  client.println("Content-Type: text/html"); //Empieza el cuerpo de la respuesta indicando que el contenido será un documento html
  client.println(""); // Ponemos un espacio
  client.println("<!DOCTYPE HTML>"); //Indicamos el inicio del Documento HTML
  client.println("<html lang=\"en\">");
  client.println("<head>");
  client.println("<meta charset=\"UTF-8\">");
  
  client.println("<meta name=\"viewport\" content=\"width=device-width, initial-scale=1.0\">"); //Para que se adapte en móviles
  client.println("<title>Cultivo</title>");
  client.println("</head>");
  client.println("<body style=background-color:#4ad4df>");
 
  client.println("<br><br>");
  
  client.println("<h1 style=\"text-align: center;\">AcuariosYMascotas</h1>");
  client.println("<h2 style=\"text-align: center;\">Estado");
  client.println(estado);
  client.println("</h2>");
  client.println("<p style=\"text-align: center;\">"); 
  client.println("<h1 style=\"text-align: center;\">Cultivo Auto</h1>");
  client.println("<p style=\"text-align: center;\">"); 
  client.println("<button onclick=location.href=\"/P=ONAUTO\">ON</button> <br> <br>"); // Botón sencillo que contiene hipervínculo
  client.println("<button onclick=location.href=\"/P=OFFAUTO\">OFF</button> <br> <br>"); // Botón sencillo que contiene hipervínculo
  client.println("</p>");
  client.println("<h1 style=\"text-align: center;\">Cosechar</h1>");
  client.println("<p style=\"text-align: center;\">"); 
  client.println("<button onclick=location.href=\"/P=preparar\" >Preparar</button> <br> <br>");
  client.println("<button onclick=location.href=\"/P=sacar500\" >500Ml</button> <br> <br>");
  client.println("<button onclick=location.href=\"/P=sacar1000\" >1000Ml</button> <br> <br>");
  client.println("<h3 style=\"text-align: center;\">Cultivos sacados ");
  client.println(contador);
  client.println("</h3>");
  client.println("<button onclick=location.href=\"/P=Reset\">Reset</button> <br> <br>"); 
  client.println("</p>");
  client.println("<h1 style=\"text-align: center;\">Prueba Servos</h1>");
  client.println("<p style=\"text-align: center;\">"); 
  client.println("<button onclick=location.href=\"/P=Servos\">ON</button> <br> <br>");
  client.println("<button onclick=location.href=\"/P=OFFServos\">OFF</button> <br> <br>");
   client.println("</p>");
  client.println("<h1 style=\"text-align: center;\">Alimentacion</h1>");
  client.println("<p style=\"text-align: center;\">"); 
    client.println("<button onclick=location.href=\"/P=Fito4\" >4ml</button> <br> <br>");
    client.println("<button onclick=location.href=\"/P=Fito5\" >5ml</button> <br> <br>");
    client.println("<button onclick=location.href=\"/P=Fito6\" >6ml</button> <br> <br>");
    client.println("</p>");
  client.println("</body>");
  
  client.println("</html>"); //Terminamos el HTML
  
  delay(1);
  //Serial.println("Cliente desconectado"); //Imprimimos que terminó el proceso con el cliente desconectado
  //Serial.println("");
 
 
}

 
